/*
 * Copyright (c) 2021-2021, Huawei Technologies Co., Ltd. All rights reserved.
 * Copyright (c) 2020-2021 Huawei Device Co., Ltd. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this list of
 * conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list
 * of conditions and the following disclaimer in the documentation and/or other materials
 * provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its contributors may be used
 * to endorse or promote products derived from this software without specific prior written
 * permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "lt_net_netdb.h"
// 引入头文件，包含了网络数据库相关的函数声明和宏定义。

static int GetNetBynametTest(void)
{
    char network_file[] = "# symbolic names for networks, see networks(5) for more information\n"
                          "link-local 169.254.0.0\n";
    // 定义一个模拟的networks文件内容，包含网络名称和对应的地址。
    char *pathList[] = {"/etc/networks"};
    // 定义networks文件的路径列表，这里只有一个路径指向系统的networks文件。
    char *streamList[] = {static_cast<char *>(network_file)};
    // 定义模拟的networks文件流列表，这里将模拟的networks文件内容转换为char*类型。
    int streamLen[] = {sizeof(network_file)};
    // 定义模拟的networks文件流长度列表。
    const int file_number = 1;
    // 定义文件数量。
    int flag = PrepareFileEnv(pathList, streamList, streamLen, file_number);
    // 调用PrepareFileEnv函数准备文件环境，模拟networks文件。
    if (flag != 0) {
        RecoveryFileEnv(pathList, file_number);
        return -1;
    }
    // 如果准备文件环境失败，则恢复原始文件环境并返回错误码。

    struct netent *se1 = nullptr;
    struct netent *se2 = nullptr;
    struct netent *se3 = nullptr;

    se1 = getnetbyname("link-local");
    // 使用getnetbyname函数根据网络名称"link-local"获取netent结构体指针。
    ICUNIT_ASSERT_NOT_EQUAL(se1, nullptr, -1);
    // 断言se1不为空，即getnetbyname成功。
    ICUNIT_ASSERT_STRING_EQUAL(se1->n_name, "link-local", -1);
    // 断言返回的网络名称与"link-local"相同。
    ICUNIT_ASSERT_EQUAL(se1->n_addrtype, AF_INET, -1);
    // 断言返回的地址类型为AF_INET（IPv4）。
    ICUNIT_ASSERT_EQUAL(se1->n_net, inet_network("169.254.0.0"), -1);
    // 断言返回的网络地址与"169.254.0.0"相同。

    se2 = getnetbyname("link");
    // 尝试使用getnetbyname函数根据不完整的网络名称"link"获取netent结构体指针，预期失败。
    ICUNIT_ASSERT_EQUAL(se2, nullptr, -1);

    se3 = getnetbyname("hs");
    // 尝试使用getnetbyname函数根据不存在的网络名称"hs"获取netent结构体指针，预期失败。
    ICUNIT_ASSERT_EQUAL(se3, nullptr, -1);

    RecoveryFileEnv(pathList, file_number);
    // 恢复原始文件环境。
    return ICUNIT_SUCCESS;
    // 返回测试成功。
}

void NetNetDbTest021(void)
{
    TEST_ADD_CASE(__FUNCTION__, GetNetBynametTest, TEST_POSIX, TEST_TCP, TEST_LEVEL0, TEST_FUNCTION);
}
// 定义测试用例，将GetNetBynametTest函数注册为一个测试案例。